=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpAnsibleClient
  class PulpAnsibleArtifactsCollectionsV3Api
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Upload a collection
    # Create an artifact and trigger an asynchronous task to create Collection content from it.
    # @param path [String] 
    # @param file [File] The Collection tarball.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :sha256 An optional sha256 checksum of the uploaded file.
    # @option opts [String] :expected_namespace The expected &#39;namespace&#39; of the Collection to be verified against the metadata during import.
    # @option opts [String] :expected_name The expected &#39;name&#39; of the Collection to be verified against the metadata during import.
    # @option opts [String] :expected_version The expected version of the Collection to be verified against the metadata during import.
    # @return [AsyncOperationResponse]
    def create(path, file, opts = {})
      data, _status_code, _headers = create_with_http_info(path, file, opts)
      data
    end

    # Upload a collection
    # Create an artifact and trigger an asynchronous task to create Collection content from it.
    # @param path [String] 
    # @param file [File] The Collection tarball.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :sha256 An optional sha256 checksum of the uploaded file.
    # @option opts [String] :expected_namespace The expected &#39;namespace&#39; of the Collection to be verified against the metadata during import.
    # @option opts [String] :expected_name The expected &#39;name&#39; of the Collection to be verified against the metadata during import.
    # @option opts [String] :expected_version The expected version of the Collection to be verified against the metadata during import.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(path, file, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleArtifactsCollectionsV3Api.create ...'
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleArtifactsCollectionsV3Api.create"
      end
      # verify the required parameter 'file' is set
      if @api_client.config.client_side_validation && file.nil?
        fail ArgumentError, "Missing the required parameter 'file' when calling PulpAnsibleArtifactsCollectionsV3Api.create"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/artifacts/collections/'.sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['file'] = file
      form_params['sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      form_params['expected_namespace'] = opts[:'expected_namespace'] if !opts[:'expected_namespace'].nil?
      form_params['expected_name'] = opts[:'expected_name'] if !opts[:'expected_name'].nil?
      form_params['expected_version'] = opts[:'expected_version'] if !opts[:'expected_version'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleArtifactsCollectionsV3Api#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
