=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module PulpAnsibleClient
  # A serializer for CollectionVersion Content.
  class AnsibleCollectionVersionResponse
    # Artifact file representing the physical content
    attr_accessor :artifact

    # Timestamp of creation.
    attr_accessor :pulp_created

    attr_accessor :pulp_href

    # The MD5 checksum if available.
    attr_accessor :md5

    # The SHA-1 checksum if available.
    attr_accessor :sha1

    # The SHA-224 checksum if available.
    attr_accessor :sha224

    # The SHA-256 checksum if available.
    attr_accessor :sha256

    # The SHA-384 checksum if available.
    attr_accessor :sha384

    # The SHA-512 checksum if available.
    attr_accessor :sha512

    # A collection identifier.
    attr_accessor :id

    # A list of the CollectionVersion content's authors.
    attr_accessor :authors

    # A JSON field with data about the contents.
    attr_accessor :contents

    # A dict declaring Collections that this collection requires to be installed for it to be usable.
    attr_accessor :dependencies

    # A short summary description of the collection.
    attr_accessor :description

    # A JSON field holding the various documentation blobs in the collection.
    attr_accessor :docs_blob

    # A JSON field holding MANIFEST.json data.
    attr_accessor :manifest

    # A JSON field holding FILES.json data.
    attr_accessor :files

    # The URL to any online docs.
    attr_accessor :documentation

    # The URL to the homepage of the collection/project.
    attr_accessor :homepage

    # The URL to the collection issue tracker.
    attr_accessor :issues

    # A list of licenses for content inside of a collection.
    attr_accessor :license

    # The name of the collection.
    attr_accessor :name

    # The namespace of the collection.
    attr_accessor :namespace

    # The URL of the originating SCM repository.
    attr_accessor :repository

    attr_accessor :tags

    # The version of the collection.
    attr_accessor :version

    # The version of Ansible required to use the collection. Multiple versions can be separated with a comma.
    attr_accessor :requires_ansible

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'artifact' => :'artifact',
        :'pulp_created' => :'pulp_created',
        :'pulp_href' => :'pulp_href',
        :'md5' => :'md5',
        :'sha1' => :'sha1',
        :'sha224' => :'sha224',
        :'sha256' => :'sha256',
        :'sha384' => :'sha384',
        :'sha512' => :'sha512',
        :'id' => :'id',
        :'authors' => :'authors',
        :'contents' => :'contents',
        :'dependencies' => :'dependencies',
        :'description' => :'description',
        :'docs_blob' => :'docs_blob',
        :'manifest' => :'manifest',
        :'files' => :'files',
        :'documentation' => :'documentation',
        :'homepage' => :'homepage',
        :'issues' => :'issues',
        :'license' => :'license',
        :'name' => :'name',
        :'namespace' => :'namespace',
        :'repository' => :'repository',
        :'tags' => :'tags',
        :'version' => :'version',
        :'requires_ansible' => :'requires_ansible'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'artifact' => :'String',
        :'pulp_created' => :'DateTime',
        :'pulp_href' => :'String',
        :'md5' => :'String',
        :'sha1' => :'String',
        :'sha224' => :'String',
        :'sha256' => :'String',
        :'sha384' => :'String',
        :'sha512' => :'String',
        :'id' => :'String',
        :'authors' => :'Array<String>',
        :'contents' => :'Object',
        :'dependencies' => :'Object',
        :'description' => :'String',
        :'docs_blob' => :'Object',
        :'manifest' => :'Object',
        :'files' => :'Object',
        :'documentation' => :'String',
        :'homepage' => :'String',
        :'issues' => :'String',
        :'license' => :'Array<String>',
        :'name' => :'String',
        :'namespace' => :'String',
        :'repository' => :'String',
        :'tags' => :'Array<AnsibleTagResponse>',
        :'version' => :'String',
        :'requires_ansible' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'requires_ansible'
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpAnsibleClient::AnsibleCollectionVersionResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpAnsibleClient::AnsibleCollectionVersionResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'artifact')
        self.artifact = attributes[:'artifact']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'md5')
        self.md5 = attributes[:'md5']
      end

      if attributes.key?(:'sha1')
        self.sha1 = attributes[:'sha1']
      end

      if attributes.key?(:'sha224')
        self.sha224 = attributes[:'sha224']
      end

      if attributes.key?(:'sha256')
        self.sha256 = attributes[:'sha256']
      end

      if attributes.key?(:'sha384')
        self.sha384 = attributes[:'sha384']
      end

      if attributes.key?(:'sha512')
        self.sha512 = attributes[:'sha512']
      end

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'authors')
        if (value = attributes[:'authors']).is_a?(Array)
          self.authors = value
        end
      end

      if attributes.key?(:'contents')
        self.contents = attributes[:'contents']
      end

      if attributes.key?(:'dependencies')
        self.dependencies = attributes[:'dependencies']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'docs_blob')
        self.docs_blob = attributes[:'docs_blob']
      end

      if attributes.key?(:'manifest')
        self.manifest = attributes[:'manifest']
      end

      if attributes.key?(:'files')
        self.files = attributes[:'files']
      end

      if attributes.key?(:'documentation')
        self.documentation = attributes[:'documentation']
      end

      if attributes.key?(:'homepage')
        self.homepage = attributes[:'homepage']
      end

      if attributes.key?(:'issues')
        self.issues = attributes[:'issues']
      end

      if attributes.key?(:'license')
        if (value = attributes[:'license']).is_a?(Array)
          self.license = value
        end
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'namespace')
        self.namespace = attributes[:'namespace']
      end

      if attributes.key?(:'repository')
        self.repository = attributes[:'repository']
      end

      if attributes.key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.key?(:'requires_ansible')
        self.requires_ansible = attributes[:'requires_ansible']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @artifact.nil?
        invalid_properties.push('invalid value for "artifact", artifact cannot be nil.')
      end

      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @authors.nil?
        invalid_properties.push('invalid value for "authors", authors cannot be nil.')
      end

      if @contents.nil?
        invalid_properties.push('invalid value for "contents", contents cannot be nil.')
      end

      if @dependencies.nil?
        invalid_properties.push('invalid value for "dependencies", dependencies cannot be nil.')
      end

      if @description.nil?
        invalid_properties.push('invalid value for "description", description cannot be nil.')
      end

      if @docs_blob.nil?
        invalid_properties.push('invalid value for "docs_blob", docs_blob cannot be nil.')
      end

      if @manifest.nil?
        invalid_properties.push('invalid value for "manifest", manifest cannot be nil.')
      end

      if @files.nil?
        invalid_properties.push('invalid value for "files", files cannot be nil.')
      end

      if @documentation.nil?
        invalid_properties.push('invalid value for "documentation", documentation cannot be nil.')
      end

      if @documentation.to_s.length > 2000
        invalid_properties.push('invalid value for "documentation", the character length must be smaller than or equal to 2000.')
      end

      if @homepage.nil?
        invalid_properties.push('invalid value for "homepage", homepage cannot be nil.')
      end

      if @homepage.to_s.length > 2000
        invalid_properties.push('invalid value for "homepage", the character length must be smaller than or equal to 2000.')
      end

      if @issues.nil?
        invalid_properties.push('invalid value for "issues", issues cannot be nil.')
      end

      if @issues.to_s.length > 2000
        invalid_properties.push('invalid value for "issues", the character length must be smaller than or equal to 2000.')
      end

      if @license.nil?
        invalid_properties.push('invalid value for "license", license cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @name.to_s.length > 64
        invalid_properties.push('invalid value for "name", the character length must be smaller than or equal to 64.')
      end

      if @namespace.nil?
        invalid_properties.push('invalid value for "namespace", namespace cannot be nil.')
      end

      if @namespace.to_s.length > 64
        invalid_properties.push('invalid value for "namespace", the character length must be smaller than or equal to 64.')
      end

      if @repository.nil?
        invalid_properties.push('invalid value for "repository", repository cannot be nil.')
      end

      if @repository.to_s.length > 2000
        invalid_properties.push('invalid value for "repository", the character length must be smaller than or equal to 2000.')
      end

      if @version.nil?
        invalid_properties.push('invalid value for "version", version cannot be nil.')
      end

      if @version.to_s.length > 128
        invalid_properties.push('invalid value for "version", the character length must be smaller than or equal to 128.')
      end

      if !@requires_ansible.nil? && @requires_ansible.to_s.length > 255
        invalid_properties.push('invalid value for "requires_ansible", the character length must be smaller than or equal to 255.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @artifact.nil?
      return false if @id.nil?
      return false if @authors.nil?
      return false if @contents.nil?
      return false if @dependencies.nil?
      return false if @description.nil?
      return false if @docs_blob.nil?
      return false if @manifest.nil?
      return false if @files.nil?
      return false if @documentation.nil?
      return false if @documentation.to_s.length > 2000
      return false if @homepage.nil?
      return false if @homepage.to_s.length > 2000
      return false if @issues.nil?
      return false if @issues.to_s.length > 2000
      return false if @license.nil?
      return false if @name.nil?
      return false if @name.to_s.length > 64
      return false if @namespace.nil?
      return false if @namespace.to_s.length > 64
      return false if @repository.nil?
      return false if @repository.to_s.length > 2000
      return false if @version.nil?
      return false if @version.to_s.length > 128
      return false if !@requires_ansible.nil? && @requires_ansible.to_s.length > 255
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] documentation Value to be assigned
    def documentation=(documentation)
      if documentation.nil?
        fail ArgumentError, 'documentation cannot be nil'
      end

      if documentation.to_s.length > 2000
        fail ArgumentError, 'invalid value for "documentation", the character length must be smaller than or equal to 2000.'
      end

      @documentation = documentation
    end

    # Custom attribute writer method with validation
    # @param [Object] homepage Value to be assigned
    def homepage=(homepage)
      if homepage.nil?
        fail ArgumentError, 'homepage cannot be nil'
      end

      if homepage.to_s.length > 2000
        fail ArgumentError, 'invalid value for "homepage", the character length must be smaller than or equal to 2000.'
      end

      @homepage = homepage
    end

    # Custom attribute writer method with validation
    # @param [Object] issues Value to be assigned
    def issues=(issues)
      if issues.nil?
        fail ArgumentError, 'issues cannot be nil'
      end

      if issues.to_s.length > 2000
        fail ArgumentError, 'invalid value for "issues", the character length must be smaller than or equal to 2000.'
      end

      @issues = issues
    end

    # Custom attribute writer method with validation
    # @param [Object] name Value to be assigned
    def name=(name)
      if name.nil?
        fail ArgumentError, 'name cannot be nil'
      end

      if name.to_s.length > 64
        fail ArgumentError, 'invalid value for "name", the character length must be smaller than or equal to 64.'
      end

      @name = name
    end

    # Custom attribute writer method with validation
    # @param [Object] namespace Value to be assigned
    def namespace=(namespace)
      if namespace.nil?
        fail ArgumentError, 'namespace cannot be nil'
      end

      if namespace.to_s.length > 64
        fail ArgumentError, 'invalid value for "namespace", the character length must be smaller than or equal to 64.'
      end

      @namespace = namespace
    end

    # Custom attribute writer method with validation
    # @param [Object] repository Value to be assigned
    def repository=(repository)
      if repository.nil?
        fail ArgumentError, 'repository cannot be nil'
      end

      if repository.to_s.length > 2000
        fail ArgumentError, 'invalid value for "repository", the character length must be smaller than or equal to 2000.'
      end

      @repository = repository
    end

    # Custom attribute writer method with validation
    # @param [Object] version Value to be assigned
    def version=(version)
      if version.nil?
        fail ArgumentError, 'version cannot be nil'
      end

      if version.to_s.length > 128
        fail ArgumentError, 'invalid value for "version", the character length must be smaller than or equal to 128.'
      end

      @version = version
    end

    # Custom attribute writer method with validation
    # @param [Object] requires_ansible Value to be assigned
    def requires_ansible=(requires_ansible)
      if !requires_ansible.nil? && requires_ansible.to_s.length > 255
        fail ArgumentError, 'invalid value for "requires_ansible", the character length must be smaller than or equal to 255.'
      end

      @requires_ansible = requires_ansible
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          artifact == o.artifact &&
          pulp_created == o.pulp_created &&
          pulp_href == o.pulp_href &&
          md5 == o.md5 &&
          sha1 == o.sha1 &&
          sha224 == o.sha224 &&
          sha256 == o.sha256 &&
          sha384 == o.sha384 &&
          sha512 == o.sha512 &&
          id == o.id &&
          authors == o.authors &&
          contents == o.contents &&
          dependencies == o.dependencies &&
          description == o.description &&
          docs_blob == o.docs_blob &&
          manifest == o.manifest &&
          files == o.files &&
          documentation == o.documentation &&
          homepage == o.homepage &&
          issues == o.issues &&
          license == o.license &&
          name == o.name &&
          namespace == o.namespace &&
          repository == o.repository &&
          tags == o.tags &&
          version == o.version &&
          requires_ansible == o.requires_ansible
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [artifact, pulp_created, pulp_href, md5, sha1, sha224, sha256, sha384, sha512, id, authors, contents, dependencies, description, docs_blob, manifest, files, documentation, homepage, issues, license, name, namespace, repository, tags, version, requires_ansible].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        PulpAnsibleClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
